<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 7.2">
  <meta name="robots" content="noindex">
  <meta name="date" content="2024-02-16">
  <link rel="icon" href="favicon-matrix.png" type="image/png">
  <link rel="apple-touch-icon" sizes="72x72" href="icon-matrix.png">
  <link rel="stylesheet" href="style.css">
</head>
<body>
  <?php
    if (file_exists('menu.php')) { include 'menu.php'; }  // wenn Menü vorhanden -> einbinden
    else { echo "<h1>&nbsp;Matrixuhr-Konfiguration</h1>\n"; } // wenn Menü nicht vorhanden -> Überschrift verwenden
    $cfgdir = '/srv/sensor';                              // Verzeichnis für Konfig-Daten
    $sename = '/senmu';                                   // Name der Sensordatei
    $slname = '/senlmu';                                  // Name der Sensorlistendatei
    $alname = '/almu';                                    // Name der Alarmdateien (Basisname)
    $bdname = '/bdaymu';                                  // Name der Geburtstagsdatei
    $bsname = '/bdaysmu';                                 // Name der Geburtstagssortierungsdatei
    $msname = '/messagemu';                               // Name der Nachrichtendatei, beim Backup wird '.s' ergänzt
    $tmname = '/timemu';                                  // Name der Zeitsynchronisierungsdatei
    $mqname = '/mqttmu';                                  // Name der MQTT-Konfigurationsdatei
    $wename = '/weatmu';                                  // Name der Wetterdaten-Konfigurationsdatei
    $sdname = '/sdatmu';                                  // Name der MQTT-Konfigurationsdatei für spezielle Daten
    $caname = '/callmu';                                  // Name der Anruf-Konfigurationsdatei
    $w1name = '/s32mu';                                   // Name der Sensor-Konfiguration (1-Wire)
    $chname = '/changemu';                                // Name der Änderungsdatei

    $msgok = 0;                                           // Flag für Bestätigung löschen
    if (isset($_POST['msgsend'])) {                       // wenn neue Nachricht eingegeben
      $msg = $_POST['msg'];                               // Nachricht holen
      if ($msg > '') {                                    // wenn gültige Nachricht
        $msgfile = fopen($cfgdir . $msname, "w");         // Nachrichtendatei erstellen
        fwrite($msgfile, html_entity_decode($msg, ENT_HTML5, "UTF-8")); // Nachricht konvertieren und schreiben
        fwrite($msgfile, "\n");                           // Zeilenendezeichen schreiben
        fclose($msgfile);                                 // Datei schließen
        $msgok = 1;                                       // Flag für Bestätigung setzen
      }
    }

    $bdok = 0;                                            // Flag für Bestätigung löschen
    if (isset($_POST['bdmu'])) {                          // wenn neue Geburtstagsdaten gesendet
      $bdarray = array();                                 // Feld für Geburtstagsdaten anlegen
      $end = $_POST['bdend'];                             // Versteckten Wert holen, enthält Anzahl der Zeilen + 1
      for ($i = 1; $i < $end; $i++) {                     // Schleife zum Lesen der Datenzeilen
        $day = $_POST['day' . $i];                        // Tag holen
        while (strlen($day) < 2) { $day = '0' . $day; }   // solange Tag nicht zweistellig -> 0 voranstellen
        if ($day == '00') { $day = '01'; }                // wenn keine Eingabe -> Tag 01 setzen
        $mon = $_POST['mon' . $i];                        // Monat holen
        while (strlen($mon) < 2) { $mon = '0' . $mon; }   // solange Monat nicht zweistellig -> 0 voranstellen
        if ($mon == '00') { $mon = '01'; }                // wenn keine Eingabe -> Monat 01 setzen
        $yea = $_POST['yea' . $i];                        // Jahr holen
        while (strlen($yea) < 4) { $yea = '0' . $yea; }   // solange Jahr nicht vierstellig -> 0 voranstellen
        if ($yea == '0000') { $yea = '2000'; }            // wenn keine Eingabe -> Jahr 2000 setzen
        $nam = html_entity_decode($_POST['nam' . $i], ENT_HTML5, "UTF-8"); // Name holen und konvertieren
        if (($nam > '') && ($nam != array_key_exists($nam, $bdarray))) {   // wenn Name ok und noch nicht vorhanden
          $bdarray[$nam] = $mon . $day . $yea;            // Name und Geburtstag (MMDDYYYY) in Feld schreiben
        }
      }
      $bds = $_POST['bds'];                               // Geburtstagssortierung holen
      if ($bds == 0) { asort($bdarray); }                 // wenn Sortierung nach Datum -> ausführen
      if ($bds == 1) { ksort($bdarray); }                 // wenn Sortierung nach Name -> ausführen
      $bdfile = fopen($cfgdir . $bdname, "w");            // neue Geburtstagsdatei erstellen
      foreach ($bdarray as $nam => $date) {               // Schleife für alle Einträge -> in Geburtstagsdatei speich.
        fwrite($bdfile, substr($date, 4, 4) . substr($date, 0, 2) . substr($date, 2, 2) . " " . $nam . "\n");
      }
      fclose($bdfile);                                    // Geburtstagsdatei schließen
      chmod($cfgdir . $bdname, 0664);                     // Rechte anpassen (pi darf schreiben)
      $bsfile = fopen($cfgdir . $bsname, "w");            // neue Geburtstagssortierungsdatei erstellen
      fwrite($bsfile, $bds . "\n");                       // Sortierungseinstellung schreiben
      fclose($bsfile);                                    // und wieder schließen
      $chfile = fopen($cfgdir . $chname, "w");            // neue Change-Datei erstellen
      fwrite($chfile, "Restart\n");                       // Kommando "Restart" schreiben
      fclose($chfile);                                    // und wieder schließen
      $bdok = 1;                                          // Flag für Bestätigung setzen
    }

    $senlok = 0;                                          // Flag für Bestätigung löschen
    if (isset($_POST['senlmu'])) {                        // wenn neue Sensorliste gesendet
      $slfile = fopen($cfgdir . $slname, "w");            // neue Sensorlistendatei erstellen
      $end = $_POST['slend'];                             // versteckten Wert holen, enthält Anzahl der Zeilen + 1
      if ($end > 13) { $end = 13; }                       // wenn maximale Anzahl überschritten -> auf 12 setzen
      for ($i = 1; $i < $end; $i++) {                     // Schleife zum Lesen der Datenzeilen
        $slline = html_entity_decode($_POST['top' . $i], ENT_HTML5, "UTF-8"); // Topic-Name holen und konvertieren
        $slline = $slline . ' ' . $_POST['fmt' . $i];     // Datenformat (0-3) ergänzen
        if (strlen($slline) > 2) {                        // wenn gültiges Topic
          fwrite($slfile, $slline . "\n");                // Datenzeile schreiben
        }
      }
      fclose($slfile);                                    // Sensorlistendatei schließen
      chmod($cfgdir . $slname, 0664);                     // Rechte anpassen (pi darf schreiben)
      $w1file = fopen($cfgdir . $w1name, "w");            // neue 1-Wire-Datei erstellen
      fwrite($w1file, $_POST['w1offs'] . "\n");           // Offset schreiben
      fclose($w1file);                                    // 1-Wire-Datei schließen
      chmod($cfgdir . $w1name, 0664);                     // Rechte anpassen (pi darf schreiben)
      $chfile = fopen($cfgdir . $chname, "w");            // neue Change-Datei erstellen
      fwrite($chfile, "Restart\n");                       // Kommando "Restart" schreiben
      fclose($chfile);                                    // und wieder schließen
      $senlok = 1;                                        // Flag für Bestätigung setzen
    }

    $senok = 0;                                           // Flag für Bestätigung löschen
    if (isset($_POST['senmu'])) {                         // wenn neue Sensordaten gesendet
      $senfile = fopen($cfgdir . $sename, "w");           // neue Sensordatei erstellen
      $end = $_POST['senend'];                            // versteckten Wert holen, enthält Anzahl der Zeilen + 1
      for ($i = 1; $i < $end; $i++) {                     // Schleife zum Lesen der Datenzeilen
        $senline = $_POST['sen' . $i];                    // Sensorzeile holen
        if ($senline > '') {                              // wenn gültige Sensorzeile
          fwrite($senfile, html_entity_decode($senline, ENT_HTML5, "UTF-8")); // konvertieren und schreiben
          fwrite($senfile, "\n");                         // Zeilenendezeichen schreiben
        }
      }
      fclose($senfile);                                   // Sensordatei schließen
      chmod($cfgdir . $sename, 0664);                     // Rechte anpassen (pi darf schreiben)
      $chfile = fopen($cfgdir . $chname, "w");            // neue Change-Datei erstellen
      fwrite($chfile, "Restart\n");                       // Kommando "Restart" schreiben
      fclose($chfile);                                    // und wieder schließen
      $senok = 1;                                         // Flag für Bestätigung setzen
    }

    $alok = 0;                                            // Flag für Bestätigung löschen
    if (isset($_POST['almu'])) {                          // wenn neue Alarmdaten gesendet
      for ($i = 1; $i < 9; $i++) {                        // 8 Alarmdateien bearbeiten
        $afile = fopen($cfgdir . $alname . $i, "w");      // neue Alarmdatei erstellen
        $aline = $_POST['snd' . $i] . $_POST['hld' . $i]; // Alarmsound und Halte-Modus holen
        $aline .= html_entity_decode($_POST['txt' . $i], ENT_HTML5, "UTF-8"); // Alarmtext holen und ergänzen
        fwrite($afile, $aline . "\n");                    // Alarmdaten schreiben
        $acond = $_POST['cnd' . $i];                      // Bedingung holen
        if ($acond > '') {                                // wenn gültiges Topic oder gültige Bedingung
          fwrite($afile, $acond . "\n");                  // Topic oder Bedingung schreiben
        }
        fclose($afile);                                   // Alarmdatei schließen
        chmod($cfgdir . $alname . $i, 0664);              // Rechte anpassen (pi darf schreiben)
      }
      $chfile = fopen($cfgdir . $chname, "w");            // neue Change-Datei erstellen
      fwrite($chfile, "Restart\n");                       // Kommando "Restart" schreiben
      fclose($chfile);                                    // und wieder schließen
      $alok = 1;                                          // Flag für Bestätigung setzen
    }

    $anrok = 0;                                           // Flag für Bestätigung löschen
    if (isset($_POST['callmu'])) {                        // wenn neue Anruf-Einstellungen gesendet
      $cafile = fopen($cfgdir . $caname, "w");            // neue Anruf-Konfigurationsdatei erstellen
      fwrite($cafile, $_POST['caanum'] . "\n");           // Alarmnummer schreiben
      fwrite($cafile, html_entity_decode($_POST['canumb'], ENT_HTML5, "UTF-8") . "\n"); // eigene Nummer schreiben
      fwrite($cafile, html_entity_decode($_POST['caevnt'], ENT_HTML5, "UTF-8") . "\n"); // Ereignis schreiben
      fwrite($cafile, html_entity_decode($_POST['caname'], ENT_HTML5, "UTF-8") . "\n"); // Name schreiben
      fwrite($cafile, html_entity_decode($_POST['caextn'], ENT_HTML5, "UTF-8") . "\n"); // Externe Nummer schreiben
      fwrite($cafile, html_entity_decode($_POST['caintn'], ENT_HTML5, "UTF-8") . "\n"); // Interne Nummer schreiben
      fclose($cafile);                                    // Anruf-Konfiguration schließen
      chmod($cfgdir . $caname, 0664);                     // Rechte anpassen (pi darf schreiben)
      $chfile = fopen($cfgdir . $chname, "w");            // neue Change-Datei erstellen
      fwrite($chfile, "Restart\n");                       // Kommando "Restart" schreiben
      fclose($chfile);                                    // und wieder schließen
      $anrok = 1;                                         // Flag für Bestätigung setzen
    }

    $sysok = 0;                                           // Flag für Bestätigung löschen
    if (isset($_POST['syssave'])) {                       // wenn System-Einstellungen gesendet
      if (isset($_POST['tmuse'])) { $tmuse = 1; }         // wenn Synchronisierung gesetzt -> Wert auf 1 setzen
      else { $tmuse = 0; }                                // sonst Wert auf 0 setzen
      $tmfile = fopen($cfgdir . $tmname, "w");            // Zeitsynchronisierungsdatei erstellen
      fwrite($tmfile, $tmuse . "\n");                     // Aktivierung schreiben
      fwrite($tmfile, $_POST['tmival'] . "\n");           // Intervall schreiben
      fclose($tmfile);                                    // Datei schließen
      chmod($cfgdir . $tmname, 0664);                     // Rechte anpassen (pi darf schreiben)
      if (isset($_POST['mqttuse'])) { $mqttuse = 1; }     // wenn MQTT-Aktivierung gesetzt -> Wert auf 1 setzen
      else { $mqttuse = 0; }                              // sonst Wert auf 0 setzen
      $mqttfile = fopen($cfgdir . $mqname, "w");          // neue MQTT-Einstellungsdatei erstellen
      fwrite($mqttfile, $mqttuse . "\n");                 // MQTT-Aktivierung schreiben
      fwrite($mqttfile, $_POST['mqttaddr'] . "\n");       // MQTT-Server-Adresse schreiben
      fwrite($mqttfile, $_POST['mqttport'] . "\n");       // MQTT-Server-Port schreiben
      fwrite($mqttfile, $_POST['mqttvali'] . "\n");       // MQTT-Server-Gültigkeitsdauer schreiben
      fwrite($mqttfile, $_POST['mqttuser'] . "\n");       // MQTT-Username schreiben
      fwrite($mqttfile, $_POST['mqttpass'] . "\n");       // MQTT-Passwort schreiben
      fwrite($mqttfile, $_POST['mqttlwt'] . "\n");        // MQTT-LWT-Topic schreiben
      fwrite($mqttfile, $_POST['mqttupt'] . "\n");        // MQTT-Uptime-Topic schreiben
      fwrite($mqttfile, $_POST['mqttrssi'] . "\n");       // MQTT-RSSI-Topic schreiben
      fwrite($mqttfile, $_POST['mqttload'] . "\n");       // MQTT-Load-Topic schreiben
      fclose($mqttfile);                                  // MQTT-Einstellungsdatei schließen
      chmod($cfgdir . $mqname, 0664);                     // Rechte anpassen (pi darf schreiben)
      if (isset($_POST['weuse'])) { $weuse = 1; }         // wenn Wetter-Aktivierung gesetzt -> Wert auf 1 setzen
      else { $weuse = 0; }                                // sonst Wert auf 0 setzen
      $wefile = fopen($cfgdir . $wename, "w");            // neue Wetterdaten-Einstellungsdatei erstellen
      fwrite($wefile, $weuse . "\n");                     // Wetter-Aktivierung schreiben
      fwrite($wefile, $_POST['weaid'] . "\n");            // APPID schreiben
      fwrite($wefile, html_entity_decode($_POST['weloc'], ENT_HTML5, "UTF-8") . "\n"); // Ortsname konv. und schreiben
      fwrite($wefile, $_POST['welat'] . "\n");            // Breitengrad schreiben
      fwrite($wefile, $_POST['welon'] . "\n");            // Längengrad schreiben
      fwrite($wefile, $_POST['welng'] . "\n");            // Sprache schreiben
      fclose($wefile);                                    // Wetter-Einstellungsdatei schließen
      chmod($cfgdir . $wename, 0664);                     // Rechte anpassen (pi darf schreiben)
      $sdfile = fopen($cfgdir . $sdname, "w");            // neue Einstellungsdatei für spezielle Daten erstellen
      fwrite($sdfile, html_entity_decode($_POST['sdtop1'], ENT_HTML5, "UTF-8") . "\n"); // MQTT-Topic 1 schreiben
      fwrite($sdfile, html_entity_decode($_POST['sdtop2'], ENT_HTML5, "UTF-8") . "\n"); // MQTT-Topic 2 schreiben
      fwrite($sdfile, html_entity_decode($_POST['sdtop3'], ENT_HTML5, "UTF-8") . "\n"); // MQTT-Topic 3 schreiben
      fclose($sdfile);                                    // Einstellungsdatei für spezielle Daten schließen
      chmod($cfgdir . $sdname, 0664);                     // Rechte anpassen (pi darf schreiben)
      $chfile = fopen($cfgdir . $chname, "w");            // neue Change-Datei erstellen
      fwrite($chfile, "Restart\n");                       // Kommando "Restart" schreiben
      fclose($chfile);                                    // und wieder schließen
      $sysok = 1;                                         // Flag für Bestätigung setzen
    }

    $str = @file_get_contents('/proc/uptime');            // Laufzeit aus System auslesen
    $upt = sprintf("%.0f", floatval($str) / 60);          // Laufzeit in Minuten ermitteln
    if ($upt < 60) {                                      // wenn Laufzeit kürzer als eine Stunde
      if ($upt == 1) { $uptime = sprintf("%u Minute", $upt); } // wenn Laufzeit genau eine Minute -> Ausgabe setzen
      else { $uptime = sprintf("%u Minuten", $upt); }     // wenn Laufzeit nicht genau eine Minute -> Ausgabe setzen
    }
    else {                                                // wenn Laufzeit länger als eine Stunde
      if ($upt < 24 * 60) { $uptime = sprintf("%.1f Stunden", $upt / 60); } // Laufzeit < ein Tag -> Stunden setzen
      else { $uptime = sprintf("%.2f Tage", $upt / 24 / 60); } // wenn Laufzeit länger als ein Tag -> Tage setzen
    }
    $load = '';                                           // Systemlast zunächst löschen
    $str = @file_get_contents('/proc/loadavg');           // Systemlast aus System auslesen
    for ($i = 0; $i < 6; $i ++) {                         // maximal 6 Zeichen prüfen
      if (substr($str, $i, 1) > ' ') { $load .= substr($str, $i, 1); } // wenn gültiges Zeichen -> anfügen
      else { break; }                                     // wenn Leerzeichen -> Schleife abbrechen
    }
    $ssid = '';                                           // WLAN-SSID zunächst löschen
    $str = shell_exec('iwconfig wlan0');                  // WLAN-Informationen aus System auslesen
    $pos = strpos($str, "ESSID:");                        // Position der WLAN-SSID ermitteln
    if (substr($str, $pos + 6, 1) == '"') {               // wenn Anführungszeichen gefunden
      for ($i = $pos + 7; $i < $pos + 40; $i ++) {        // maximal 32 Zeichen + Anführungszeichen prüfen
        if (substr($str, $i, 1) != '"') { $ssid .= substr($str, $i, 1); } // wenn gültiges Zeichen -> anfügen
        else { break; }                                   // wenn Anführungszeichen -> Schleife abbrechen
      }
    }
    if ($ssid == '') { $ssid = 'nicht vorhanden'; }
    $rssi = '';                                           // WLAN-RSSI zunächst löschen
    $pos = strpos($str, "level=");                        // Position des RSSI-Wertes ermitteln
    for ($i = $pos + 6; $i < $pos + 10; $i ++) {          // maximal 4 Zeichen prüfen
      if (substr($str, $i, 1) > ' ') { $rssi .= substr($str, $i, 1); } // wenn gültiges Zeichen -> anfügen
      else { break; }                                     // wenn Leerzeichen -> Schleife abbrechen
    }
    if ($rssi == '') { $rssi = 'nicht vorhanden'; }
    else { $rssi.= ' dB'; }
  ?>
  <br>
  <form name="Status">
    <fieldset>
      <legend>Status</legend>
      <table class="t5">
        <tr><td>Systemlaufzeit:</td><td><?=$uptime?></td></tr>
        <tr><td>Systemauslastung:</td><td><?=$load?></td></tr>
        <tr><td>WLAN-SSID:</td><td><?=$ssid?></td></tr>
        <tr><td>WLAN-Signal:</td><td><?=$rssi?></td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Nachricht" action="<?=$_SERVER['SCRIPT_NAME']?>" method="post">
    <fieldset>
      <legend>Nachricht</legend>
      <table class="t4">
        <?php
          $msgline = '';
          if (file_exists($cfgdir . $msname)) {
            $msgfile = fopen($cfgdir . $msname, "r");
            $msgline = htmlentities(rtrim(fgets($msgfile)), ENT_HTML5, "UTF-8");
            fclose($msgfile);
          }
          else {
            if (file_exists($cfgdir . $msname . '.s')) {
              $msgfile = fopen($cfgdir . $msname . '.s', "r");
              $msgline = htmlentities(rtrim(fgets($msgfile)), ENT_HTML5, "UTF-8");
              fclose($msgfile);
            }
          }
          echo '<tr><td><input type="text" size="100" maxlength="100" ';
          echo 'name="msg" value="', $msgline, '"></td></tr>';
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="msgsend" value="Nachricht senden"></td><td>
        <?php if ($msgok == 1) { echo '<span class="m4">gesendet</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Geburtstage" action="<?=$_SERVER['SCRIPT_NAME']?>#Geburtstage" method="post">
    <a id="Geburtstage"></a>
    <fieldset>
      <legend>Geburtstage</legend>
      <table class="t5">
        <tr><td>In diese Tabelle können Geburtstage eingetragen werden. Am Geburtstag werden dann Name und Alter auf
        der Matrixuhr angezeigt. Durch Löschen des Feldes <span class="x2">Name</span> kann ein Geburtstag aus der
        Liste entfernt werden. Wichtig: Namen dürfen nicht mehrfach verwendet werden.
        [<a href="https://s-huehn.de/elektronik/matrixuhr/matrixuhr.htm#geburtstage" target="_blank">Hilfe</a>]
        </td></tr>
      </table>
      <table class="t4">
        <tr><th>Tag</th><th>Monat</th><th>Jahr</th><th>Name</th></tr>
        <?php
          if (!file_exists($cfgdir . $bdname)) {
            $bdfile = fopen($cfgdir . $bdname, "w");
            fclose($bdfile);
            chmod($cfgdir . $bdname, 0664);
          }
          if (file_exists($cfgdir . $bdname)) {
            $bdfile = fopen($cfgdir . $bdname, "r");
            $i = 1;
            do {
              $bdline = htmlentities(rtrim(fgets($bdfile)), ENT_HTML5, "UTF-8");
              $day = substr($bdline, 6, 2);
              if ($day < 10) { $day = substr($day, 1); }
              $mon = substr($bdline, 4, 2);
              if ($mon < 10) { $mon = substr($mon, 1); }
              echo '<tr><td><input type="text" size="2" maxlength="2"';
              echo ' name="day', $i, '" value="', $day, '"></td>';
              echo '<td><input type="text" size="2" maxlength="2"';
              echo ' name="mon', $i, '" value="', $mon, '"></td>';
              echo '<td><input type="text" size="4" maxlength="4"';
              echo ' name="yea', $i, '" value="', substr($bdline, 0, 4), '"></td>';
              echo '<td><input type="text" size="20" maxlength="20"';
              echo ' name="nam', $i, '" value="', substr($bdline, 9), '"></td></tr>', "\n";
              $i++;
            } while (!feof($bdfile));
            fclose($bdfile);
          }
        ?>
      </table>
      <input type="hidden" name="bdend" value="<?=$i?>">
      <table class="t4">
        <tr><td>Sortierung:</td><td>
        <?php
          if (file_exists($cfgdir . $bsname)) {
            $bsfile = fopen($cfgdir . $bsname, "r");
            $bds = rtrim(fgets($bsfile));
            fclose($bsfile);
          }
          else { $bds = 0; }
          echo '<select name="bds" size="1"><option ';
          if ($bds == '0') { echo 'selected '; }
          echo 'value="0">Datum</option><option ';
          if ($bds == '1') { echo 'selected '; }
          echo 'value="1">Name</option></select></td></tr>';
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="bdmu" value="Geburtstage speichern"></td><td>
        <?php if ($bdok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Sensorliste" action="<?=$_SERVER['SCRIPT_NAME']?>#Sensorliste" method="post">
    <a id="Sensorliste"></a>
    <fieldset>
      <legend>Sensorliste</legend>
      <table class="t5">
        <tr><td>Die nachfolgende Liste enthält alle Sensoren, die von der Matrixuhr angezeigt und ausgewertet werden
        können. Externe Sensoren müssen mit ihrem MQTT-Topic in den oberen Teil der Liste eingetragen werden.
        [<a href="https://s-huehn.de/elektronik/matrixuhr/matrixuhr.htm#sensorliste" target="_blank">Hilfe</a>]
        </td></tr>
      </table>
      <table class="t5">
        <tr><th>Name</th><th>MQTT Topic / Beschreibung</th><th>Dezimal</th></tr>
        <?php
          if (!file_exists($cfgdir . $slname)) {
            $slfile = fopen($cfgdir . $slname, "w");
            fclose($slfile);
            chmod($cfgdir . $slname, 0664);
          }
          if (file_exists($cfgdir . $slname)) {
            $slfile = fopen($cfgdir . $slname, "r");
            $i = 1;
            do {
              $slline = htmlentities(rtrim(fgets($slfile)), ENT_HTML5, "UTF-8");
              $slpos = strpos($slline, ' ');
              if ($slpos !== false) {
                $sltop = substr($slline, 0, $slpos);
                $slfmt = substr($slline, $slpos + 1, 1);
              }
              else {
                $sltop = $slline;
                $slfmt = 0;
              }
              echo '<tr><td class="ce">', chr($i + ord('A') - 1), '</td>';
              echo '<td><input type="text" size="60" maxlength="100"';
              echo ' name="top', $i, '" value="', $sltop, '"></td><td class="ce">';
              echo '<select name="fmt', $i, '" size="1"><option ';
              if ($slfmt == '0') { echo 'selected '; }
              echo 'value="0">0</option><option ';
              if ($slfmt == '1') { echo 'selected '; }
              echo 'value="1">1</option><option ';
              if ($slfmt == '2') { echo 'selected '; }
              echo 'value="2">2</option><option ';
              if ($slfmt == '3') { echo 'selected '; }
              echo 'value="3">aus</option></select></td></tr>', "\n";
              $i++;
            } while ((!feof($slfile)) && ($i < 13));
            fclose($slfile);
          }
        ?>
        <tr><td class="ce">M</td><td>Wetter: Temperaturwert in &deg;C mit einer Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">N</td><td>Wetter: Temperaturwert in &deg;C ohne Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">O</td><td>Wetter: Luftfeuchtigkeit in % ohne Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">P</td><td>Wetter: Luftdruck in hPa ohne Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">Q</td><td>Wetter: Windgeschwindigkeit in m/s mit einer Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">R</td><td>Wetter: Windgeschwindigkeit in km/h ohne Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">S</td><td>Wetter: Regenmenge in mm/h mit einer Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">T</td><td>Wetter: Regenmenge in mm/h ohne Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">U</td><td>Wetter: Wolkendichte in % ohne Nachkommastelle</td><td></td></tr>
        <tr><td class="ce">V</td><td>Wetter: Windrichtungspfeil</td><td></td></tr>
        <tr><td class="ce">W</td><td>Wetter: Wettersymbol</td><td></td></tr>
        <tr><td class="ce">X</td><td>Wetter: Wetterlage in Textform</td><td></td></tr>
        <tr><td class="ce">Y</td><td>Wetter: Sonnenaufgang/Sonnenuntergang</td><td></td></tr>
        <tr><td class="ce">Z</td><td>1-Wire-Sensor: Temperaturwert in &deg;C, Korrekturwert (-5.0 bis 5.0):</td><td class="ce">
        <?php
          if (file_exists($cfgdir . $w1name)) {
            $w1file = fopen($cfgdir . $w1name, "r");
            $w1offs = rtrim(fgets($w1file));
            fclose($w1file);
          }
          else { $w1offs = 0; }
          echo '<input type="text" size="3" maxlength="4" name="w1offs" value="', $w1offs, '">';
        ?>
        </td></tr>
        <tr><td class="ce">a</td><td>Kraftstoffdaten: Preis von Tankstelle 1 in € mit 2 Nachkommastellen</td><td></td></tr>
        <tr><td class="ce">b</td><td>Kraftstoffdaten: Preis von Tankstelle 2 in € mit 2 Nachkommastellen</td><td></td></tr>
        <tr><td class="ce">c</td><td>Kraftstoffdaten: Preis von Tankstelle 3 in € mit 2 Nachkommastellen</td><td></td></tr>
        <tr><td class="ce">d</td><td>Kraftstoffdaten: Preis von Tankstelle 4 in € mit 2 Nachkommastellen</td><td></td></tr>
      </table>
      <input type="hidden" name="slend" value="<?=$i?>">
      <table class="t4">
        <tr><td><input type="submit" name="senlmu" value="Sensorliste speichern"></td><td>
        <?php if ($senlok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Sensoren" action="<?=$_SERVER['SCRIPT_NAME']?>#Sensoren" method="post">
    <a id="Sensoren"></a>
    <fieldset>
      <legend>Sensoren</legend>
      <table class="t5">
        <tr><td>Über die nachfolgende Liste wird die Anzeige von Sensorwerten auf der Matrixuhr konfiguriert. Hier
        können alle Elemente aus der Sensorliste verwendet und mit zusätzlichen Informationen kombiniert werden.
        Hier stehen außerdem folgende Symbole zur Verfügung: $U Solarsymbol, $V Batteriesymbol, $W Tankensymbol,
        $X Wolkensymbol, $Y Windsymbol, $Z Regensymbol.
        [<a href="https://s-huehn.de/elektronik/matrixuhr/matrixuhr.htm#sensoren" target="_blank">Hilfe</a>]
        </td></tr>
      </table>
      <table class="t4">
        <?php
          if (!file_exists($cfgdir . $sename)) {
            $senfile = fopen($cfgdir . $sename, "w");
            fclose($senfile);
            chmod($cfgdir . $sename, 0664);
          }
          if (file_exists($cfgdir . $sename)) {
            $senfile = fopen($cfgdir . $sename, "r");
            $i = 1;
            do {
              $senline = htmlentities(rtrim(fgets($senfile)), ENT_HTML5, "UTF-8");
              echo '<tr><td><input type="text" size="20" maxlength="20"';
              echo ' name="sen', $i, '" value="', $senline, '"></td></tr>', "\n";
              $i++;
            } while (!feof($senfile));
            fclose($senfile);
          }
        ?>
      </table>
      <input type="hidden" name="senend" value="<?=$i?>">
      <table class="t4">
        <tr><td><input type="submit" name="senmu" value="Sensoren speichern"></td><td>
        <?php if ($senok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Alarme" action="<?=$_SERVER['SCRIPT_NAME']?>#Alarme" method="post">
    <a id="Alarme"></a>
    <fieldset>
      <legend>Alarme</legend>
      <table class="t5">
        <tr><td>Über diese Tabelle erfolgt die Ausgabe der 4 Alarme des Temperatur-Messsystems. Bei Alarmen, die nicht
        signalisiert werden sollen, muss das Feld <span class="x2">MQTT Topic</span> leer bleiben.
        [<a href="https://s-huehn.de/elektronik/matrixuhr/matrixuhr.htm#alarme" target="_blank">Hilfe</a>]</td></tr>
      </table>
      <table class="t4">
        <tr><th>Nr</th><th>Sound</th><th>Halten</th><th>Text</th><th>MQTT Topic</th></tr>
        <?php
          for ($i = 1; $i < 5; $i++) {
            echo '<tr><td>', $i, '</td>';
            if (file_exists($cfgdir . $alname . $i)) {
              $afile = fopen($cfgdir . $alname . $i, "r");
              $aline = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8");
              $acond = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8");
              fclose($afile);
            }
            else {
              $aline = '00Alarm' . $i;
              $acond = '';
            }
            echo '<td><select name="snd', $i, '" size="1">';
            for ($j = 0; $j < 7; $j++) {
              echo '<option ';
              if (substr($aline, 0, 1) == $j) { echo 'selected '; }
              echo 'value="', $j, '">', $j, '</option>';
            }
            echo '</select></td><td><select name="hld', $i, '" size="1"><option ';
            if (substr($aline, 1, 1) == '0') { echo 'selected '; }
            echo 'value="0">aus</option><option ';
            if (substr($aline, 1, 1) == '1') { echo 'selected '; }
            echo 'value="1">ein</option></select></td>';
            echo '<td><input type="text" size="20" maxlength="20"';
            echo ' name="txt', $i, '" value="', substr($aline, 2), '"></td>';
            echo '<td><input type="text" size="60" maxlength="100"';
            echo ' name="cnd', $i, '" value="', $acond, '"></td>', "</tr>\n";
          }
        ?>
      </table>
      <table class="t5">
        <tr><td>Über diese Tabelle lassen sich 4 zusätzliche Alarme definieren, die bei Unter- oder Überschreitung von
        Sensorwerten ausgelöst werden. Weiterhin ist es möglich, Alarme zu einem bestimmten Zeitpunkt auszulösen. Bei
        nicht genutzten Alarmen muss das Feld <span class="x2">Bedingung</span> leer bleiben.
        [<a href="https://s-huehn.de/elektronik/matrixuhr/matrixuhr.htm#alarme" target="_blank">Hilfe</a>]</td></tr>
      </table>
      <table class="t4">
        <tr><th>Nr</th><th>Sound</th><th>Halten</th><th>Text</th><th>Bedingung</th></tr>
        <?php
          for ($i = 5; $i < 9; $i++) {
            echo '<tr><td>', $i, '</td>';
            if (file_exists($cfgdir . $alname . $i)) {
              $afile = fopen($cfgdir . $alname . $i, "r");
              $aline = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8");
              $acond = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8");
              fclose($afile);
            }
            else {
              $aline = '00Alarm' . $i;
              $acond = '';
            }
            echo '<td><select name="snd', $i, '" size="1">';
            for ($j = 0; $j < 7; $j++) {
              echo '<option ';
              if (substr($aline, 0, 1) == $j) { echo 'selected '; }
              echo 'value="', $j, '">', $j, '</option>';
            }
            echo '</select></td><td><select name="hld', $i, '" size="1"><option ';
            if (substr($aline, 1, 1) == '0') { echo 'selected '; }
            echo 'value="0">aus</option><option ';
            if (substr($aline, 1, 1) == '1') { echo 'selected '; }
            echo 'value="1">ein</option></select></td>';
            echo '<td><input type="text" size="20" maxlength="20"';
            echo ' name="txt', $i, '" value="', substr($aline, 2), '"></td>';
            echo '<td><input type="text" size="60" maxlength="100"';
            echo ' name="cnd', $i, '" value="', $acond, '"></td>', "</tr>\n";
          }
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="almu" value="Alarme speichern"></td><td>
        <?php if ($alok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <!--
  <br>
  <form name="Anrufe" action="<?=$_SERVER['SCRIPT_NAME']?>#Anrufe" method="post">
    <a id="Anrufe"></a>
    <fieldset>
      <legend>Anrufe</legend>
      <table class="t5">
        <tr><td>Hier lässt sich die Signalisierung von Festnetz-Anrufen einrichten. Die Daten werden über MQTT von
        FHEM empfangen und als Alarm auf der Matrixuhr angezeigt.</td></tr>
      </table>
      <table class="t5">
        <?php
          if (file_exists($cfgdir . $caname)) {
            $cafile = fopen($cfgdir . $caname, "r");
            $caanum = rtrim(fgets($cafile, 50));
            $canumb = rtrim(fgets($cafile, 50));
            $caevnt = htmlentities(rtrim(fgets($cafile, 100)), ENT_HTML5, "UTF-8");
            $caname = htmlentities(rtrim(fgets($cafile, 100)), ENT_HTML5, "UTF-8");
            $caextn = htmlentities(rtrim(fgets($cafile, 100)), ENT_HTML5, "UTF-8");
            $caintn = htmlentities(rtrim(fgets($cafile, 100)), ENT_HTML5, "UTF-8");
            fclose($cafile);
          }
          else {
            $caanum = 0;
            $canumb = '';
            $caevnt = '';
            $caname = '';
            $caextn = '';
            $caintn = '';
          }
          echo '<tr><td><select name="caanum" size="1">';
          for ($j = 0; $j < 9; $j ++) {
            echo '<option ';
            if ($caanum == $j) { echo 'selected '; }
            if ($j == 0) { echo 'value="', $j, '">aus'; }
            else { echo 'value="', $j, '">', $j; }
            echo '</option>';
          }
          echo '</select></td>';
          echo "<td>verwendete Alarmnummer für die Anrufanzeige</td></tr>\n";
          echo '<tr><td><input type="text" size="20" maxlength="20"';
          echo ' name="canumb" value="', $canumb, '"></td>';
          echo "<td>nur Anrufe an diese Nummer anzeigen (leer: alle Anrufe anzeigen)</td></tr>\n";
          echo '<tr><td><input type="text" size="60" maxlength="100"';
          echo ' name="caevnt" value="', $caevnt, '"></td>';
          echo "<td>MQTT Topic für Anruf-Ereignis</td></tr>\n";
          echo '<tr><td><input type="text" size="60" maxlength="100"';
          echo ' name="caname" value="', $caname, '"></td>';
          echo "<td>MQTT Topic für Name des Anrufers</td></tr>\n";
          echo '<tr><td><input type="text" size="60" maxlength="100"';
          echo ' name="caextn" value="', $caextn, '"></td>';
          echo "<td>MQTT Topic für Nummer des Anrufers</td></tr>\n";
          echo '<tr><td><input type="text" size="60" maxlength="100"';
          echo ' name="caintn" value="', $caintn, '"></td>';
          echo "<td>MQTT Topic für die angerufene Nummer</td></tr>\n";
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="callmu" value="Anruf-Einstellungen speichern"></td><td>
        <?php if ($anrok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  -->
  <br>
  <form name="System" action="<?=$_SERVER['SCRIPT_NAME']?>#System" method="post">
    <a id="System"></a>
    <fieldset>
      <legend>System-Einstellungen</legend>
      <table class="t5">
        <tr><td>In diesem Bereich wird die Zeitsynchronisierung und die MQTT-Funktion konfiguriert. Alternativ lässt
        sich hier der direkte Empfang von Wetterdaten konfigurieren.
        [<a href="https://s-huehn.de/elektronik/matrixuhr/matrixuhr.htm#system" target="_blank">Hilfe</a>]</td></tr>
      </table>
      <table class="t5">
        <?php
          if (file_exists($cfgdir . $tmname)) {
            $tmfile = fopen($cfgdir . $tmname, "r");
            $tmuse = rtrim(fgets($tmfile));
            $tmival = rtrim(fgets($tmfile));
            fclose($tmfile);
          }
          else {
            $tmuse = 0;
            $tmival = 60;
          }
          echo '<tr><td><input type="checkbox" name="tmuse"';
          if ($tmuse == 1) { echo ' checked'; }
          echo ' value="1"></td><td>';
          echo "Matrixuhr mit der Systemzeit synchronisieren</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="3" ';
          echo 'name="tmival" value="', $tmival, '"></td><td>';
          echo 'Synchronisierungs-Intervall in Minuten (Bereich 1 bis 60) - die erste Synchronisierung';
          echo " erfolgt immer eine Minute nach Systemstart</td></tr>\n";
          echo "<tr><td>&nbsp;</td><td></td></tr>\n";

          if (file_exists($cfgdir . $mqname)) {
            $mqttfile = fopen($cfgdir . $mqname, "r");
            $mqttuse = rtrim(fgets($mqttfile));
            $mqttaddr = rtrim(fgets($mqttfile));
            $mqttport = rtrim(fgets($mqttfile));
            $mqttvali = rtrim(fgets($mqttfile));
            $mqttuser = rtrim(fgets($mqttfile));
            $mqttpass = rtrim(fgets($mqttfile));
            $mqttlwt = rtrim(fgets($mqttfile));
            $mqttupt = rtrim(fgets($mqttfile));
            $mqttrssi = rtrim(fgets($mqttfile));
            $mqttload = rtrim(fgets($mqttfile));
            fclose($mqttfile);
            if ($mqttvali == '') { $mqttvali = 2; }
          }
          else {
            $mqttuse = 0;
            $mqttaddr = 'localhost';
            $mqttport = 1883;
            $mqttvali = 2;
            $mqttuser = '';
            $mqttpass = '';
            $mqttlwt = 'Haus/Technik/Matrixuhr-1/LWT';
            $mqttupt = 'Haus/Technik/Matrixuhr-1/uptime';
            $mqttrssi = 'Haus/Technik/Matrixuhr-1/rssi';
            $mqttload = 'Haus/Technik/Matrixuhr-1/load';
          }
          echo '<tr><td><input type="checkbox" name="mqttuse"';
          if ($mqttuse == 1) { echo ' checked'; }
          echo ' value="1"></td><td>';
          echo "MQTT-Funktion aktivieren</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="mqttaddr" value="', $mqttaddr, '"></td><td>';
          echo "IP-Adresse des MQTT-Servers (wenn auf dem gleichen System installiert: localhost)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="10" ';
          echo 'name="mqttport" value="', $mqttport, '"></td><td>';
          echo "IP-Port des MQTT-Servers (Standard: 1883)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="10" ';
          echo 'name="mqttvali" value="', $mqttvali, '"></td><td>';
          echo "Gültigkeitsdauer der empfangenen Sensordaten in Minuten (Bereich 1 bis 1440)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="mqttuser" value="', $mqttuser, '"></td><td>';
          echo "Username für den MQTT-Server (nur wenn MQTT-Server mit Username/Passwort geschützt ist)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="mqttpass" value="', $mqttpass, '"></td><td>';
          echo "Passwort für den MQTT-Server (nur wenn MQTT-Server mit Username/Passwort geschützt ist)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="mqttlwt" value="', $mqttlwt, '"></td><td>';
          echo "LWT Topic (Online-Status an den MQTT-Server senden)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="mqttupt" value="', $mqttupt, '"></td><td>';
          echo "Uptime Topic (Laufzeit an den MQTT-Server senden)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="mqttrssi" value="', $mqttrssi, '"></td><td>';
          echo "RSSI Topic (WLAN-Empfangssignal an den MQTT-Server senden)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="mqttload" value="', $mqttload, '"></td><td>';
          echo "Load Topic (Systemauslastung an den MQTT-Server senden)</td></tr>\n";
          echo "<tr><td>&nbsp;</td><td></td></tr>\n";

          if (file_exists($cfgdir . $sdname)) {
            $sdfile = fopen($cfgdir . $sdname, "r");
            $sdtop1 = htmlentities(rtrim(fgets($sdfile)), ENT_HTML5, "UTF-8");
            $sdtop2 = htmlentities(rtrim(fgets($sdfile)), ENT_HTML5, "UTF-8");
            $sdtop3 = htmlentities(rtrim(fgets($sdfile)), ENT_HTML5, "UTF-8");
            fclose($sdfile);
          }
          else {
            $sdtop1 = 'Haus/Info/Wetter/aktuell';
            $sdtop2 = 'Haus/Info/Tanken/Preise';
            $sdtop3 = 'Haus/Info/Nachrichten';
          }
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="sdtop1" value="', $sdtop1, '"></td><td>';
          echo "Topic für den Empfang von Wetterinformationen über MQTT</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="sdtop2" value="', $sdtop2, '"></td><td>';
          echo "Topic für den Empfang von Kraftstoffinformationen über MQTT</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="100" ';
          echo 'name="sdtop3" value="', $sdtop3, '"></td><td>';
          echo "Topic für den Empfang von Nachrichten über MQTT</td></tr>\n";
          echo "<tr><td>&nbsp;</td><td></td></tr>\n";

          if (file_exists($cfgdir . $wename)) {
            $wefile = fopen($cfgdir . $wename, "r");
            $weuse = rtrim(fgets($wefile));
            $weaid = rtrim(fgets($wefile));
            $weloc = htmlentities(rtrim(fgets($wefile)), ENT_HTML5, "UTF-8");
            $welat = rtrim(fgets($wefile));
            $welon = rtrim(fgets($wefile));
            $welng = rtrim(fgets($wefile));
            fclose($wefile);
          }
          else {
            $weuse = 0;
            $weaid = '';
            $weloc = '';
            $welat = 0;
            $welon = 0;
            $welng = 'de';
          }
          echo '<tr><td><input type="checkbox" name="weuse"';
          if ($weuse == 1) { echo ' checked'; }
          echo ' value="1"></td><td>';
          echo "Wetterdaten von OpenWeatherMap.org verwenden</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="50" ';
          echo 'name="weaid" value="', $weaid, '"></td><td>';
          echo "APPID für OpenWeatherMap.org (Registrierung erforderlich: ";
          echo '<a href="https://openweathermap.org/price" target="_blank">';
          echo "https://openweathermap.org/price</a>)</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="50" ';
          echo 'name="weloc" value="', $weloc, '"></td><td>';
          echo "Name des Ortes - wenn Ort nicht verfügbar, dann nachfolgende Koordinatenfelder ausfüllen</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="20" ';
          echo 'name="welat" value="', $welat, '"></td><td>';
          echo "Breitengrad (z.B. 52.52) - wird nur verwendet, wenn kein Ortsame eingegeben wurde</td></tr>\n";
          echo '<tr><td><input type="text" size="40" maxlength="20" ';
          echo 'name="welon" value="', $welon, '"></td><td>';
          echo "Längengrad (z.B. 13.39) - wird nur verwendet, wenn kein Ortsame eingegeben wurde</td></tr>\n";
          echo '<tr><td><select name="welng" size="1"><option ';
          if ($welng == 'de') { echo 'selected '; }
          echo 'value="de">Deutsch</option><option ';
          if ($welng == 'en') { echo 'selected '; }
          echo 'value="en">Englisch</option></select></td>';
          echo "<td>Sprache für die aktuelle Wetterlage in Textform</td></tr>\n";
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="syssave" value="System-Einstellungen speichern"></td><td>
        <?php if ($sysok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
</body>
</html>
